"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_webserver_1 = require("quidproquo-webserver");
const executeLambdaByName_1 = require("../../../logic/lambda/executeLambdaByName");
const awsNamingUtils_1 = require("../../../awsNamingUtils");
const getServiceFunctionExecuteActionProcessor = (qpqConfig) => {
    return ({ functionName, service, payload }, session) => __awaiter(void 0, void 0, void 0, function* () {
        const region = quidproquo_core_1.qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig);
        const appName = quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
        const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
        const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
        const awsFunctionName = (0, awsNamingUtils_1.getConfigRuntimeResourceName)(`${functionName}-sfunc`, appName, service, environment, feature);
        const serviceFunctionEvent = {
            functionName: functionName,
            payload: payload,
            storySession: session,
        };
        const result = yield (0, executeLambdaByName_1.executeLambdaByName)(awsFunctionName, region, serviceFunctionEvent);
        if (result === null || result === void 0 ? void 0 : result.error) {
            return (0, quidproquo_core_1.actionResultError)(result === null || result === void 0 ? void 0 : result.error.errorType, result === null || result === void 0 ? void 0 : result.error.errorText, result === null || result === void 0 ? void 0 : result.error.errorStack);
        }
        return (0, quidproquo_core_1.actionResult)(result === null || result === void 0 ? void 0 : result.result);
    });
};
exports.default = (qpqConfig) => {
    return {
        [quidproquo_webserver_1.ServiceFunctionActionType.Execute]: getServiceFunctionExecuteActionProcessor(qpqConfig),
    };
};
