"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSecret = void 0;
const client_secrets_manager_1 = require("@aws-sdk/client-secrets-manager");
const getSecret = (secretName, region) => __awaiter(void 0, void 0, void 0, function* () {
    const smClient = new client_secrets_manager_1.SecretsManagerClient({
        region,
    });
    const response = yield smClient.send(new client_secrets_manager_1.GetSecretValueCommand({
        SecretId: secretName,
    }));
    return response.SecretString || '';
});
exports.getSecret = getSecret;
